leetcode - 1658. Minimum Operations to Reduce X to Zero

Description

You are given an integer array nums and an integer x. In one operation, you can either remove the leftmost or the rightmost element from the array nums and subtract its value from x. Note that this modifies the array for future operations.

Return the minimum number of operations to reduce x to exactly 0 if it is possible, otherwise, return -1.

Example 1:

Input: nums = [1,1,4,2,3], x = 5
Output: 2
Explanation: The optimal solution is to remove the last two elements to reduce x to zero.

Example 2:

Input: nums = [5,6,7,8,9], x = 4
Output: -1

Example 3:

Input: nums = [3,2,20,1,1,3], x = 10
Output: 5
Explanation: The optimal solution is to remove the last three elements and the first two elements (5 operations in total) to reduce x to zero.

Constraints:

1 <= nums.length <= 10^5
1 <= nums[i] <= 10^4
1 <= x <= 10^9

Solution

Recursive (TLE)

Every time try with leftest and rightest items.

Time complexity: o ( 2 n ) o(2^n) o(2n)
Space complexity: o ( n ) o(n) o(n)

Sliding window

Solved after help.

Think in reverse; instead of finding the minimum prefix + suffix, find the maximum subarray.

So the problem becomes: to find the longest subarray with target sum.

Time complexity: o ( n ) o(n) o(n)
Space complexity: o ( 1 ) o(1) o(1)

Code

Recursive (TLE)

class Solution:
    def minOperations(self, nums: List[int], x: int) -> int:
        def helper(left: int, right: int, x: int) -> int:
            if x == 0:
                return 0
            if left > right:
                return -1
            candidates = []
            if x - nums[left] >= 0:
                next_cnt = helper(left + 1, right, x - nums[left])
                if next_cnt != -1:
                    candidates.append(next_cnt + 1)
            if x - nums[right] >= 0:
                next_cnt = helper(left, right - 1, x - nums[right])
                if next_cnt != -1:
                    candidates.append(1 + next_cnt)
            return min(candidates) if candidates else -1
        return helper(0, len(nums) - 1, x)

Sliding window

class Solution:
    def minOperations(self, nums: List[int], x: int) -> int:
        array_sum = sum(nums) - x
        if array_sum < 0:
            return -1
        res = -1
        left = 0
        cur_sum = 0
        for right in range(len(nums)):
            cur_sum += nums[right]
            while cur_sum > array_sum:
                cur_sum -= nums[left]
                left += 1
            if cur_sum == array_sum:
                res = max(res, right - left + 1)
        return -1 if res == -1 else len(nums) - res
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值